<!--
~ Copyright (c) 2005-2010, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
~
~ WSO2 Inc. licenses this file to you under the Apache License,
~ Version 2.0 (the "License"); you may not use this file except
~ in compliance with the License.
~ You may obtain a copy of the License at
~
~ http://www.apache.org/licenses/LICENSE-2.0
~
~ Unless required by applicable law or agreed to in writing,
~ software distributed under the License is distributed on an
~ "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
~ KIND, either express or implied. See the License for the
~ specific language governing permissions and limitations
~ under the License.
-->

<%@ page import="org.apache.axis2.context.ConfigurationContext" %>
<%@ page import="org.apache.commons.logging.Log" %>
<%@ page import="org.apache.commons.logging.LogFactory" %>
<%@ page import="org.wso2.carbon.CarbonConstants" %>
<%@ page import="org.wso2.carbon.adminconsole.ui.AdminConsoleClient" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIUtil" %>
<%@ page import="org.wso2.carbon.utils.ServerConstants" %>

<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib uri="http://wso2.org/projects/carbon/taglibs/carbontags.jar" prefix="carbon" %>

<fmt:bundle basename="org.wso2.carbon.adminconsole.ui.i18n.Resources">
    <carbon:breadcrumb resourceBundle="org.wso2.carbon.adminconsole.ui.i18n.Resources"
                       topPage="true" request="<%=request%>" label="admin.console.header"/>

        <%
            String dbName = request.getParameter("dbName");
            final Log log = LogFactory.getLog(this.getClass());

            AdminConsoleClient client = null;
            String backendServerURL = CarbonUIUtil.getServerURL(config.getServletContext(), session);
            ConfigurationContext configContext = (ConfigurationContext) config.getServletContext().
                    getAttribute(CarbonConstants.CONFIGURATION_CONTEXT);
            String cookie = (String) session.getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);
            try {
                client = new AdminConsoleClient(cookie, backendServerURL, configContext);
            } catch (Exception e) {
                String errorMsg = e.getLocalizedMessage();
                log.error(errorMsg);
            }
        %>

<div id="middle">
        <h2><fmt:message key="admin.console.users"/></h2>

        <div id="workArea">
            <form method="post" action="manageUserProcessor.jsp" name="dataForm">
                <table class="styledLeft" id="dbUserTable">
                    <thead>
                    <tr>
                        <th width="20%"><fmt:message key="admin.console.permission.name"/></th>
                        <th width="60%"><fmt:message key="admin.console.actions"/></th>
                    </tr>
                    </thead>
                    <tbody>
                    <tr>
                        <td></td>
                        <td></td>
                    </tr>
                    <%--<tr>--%>
                        <%--<td id="<%=dbName%>"><%=dbName%>--%>
                        <%--</td>--%>
                        <%--<td id="<%=userInfoInfo.getUsername()%>"><%=userInfoInfo.getUsername() + "@" + userInfoInfo.getInstanceName()%>--%>
                        <%--</td>--%>
                        <%--<td>--%>
                            <%--<a class="icon-link"--%>
                               <%--style="background-image:url(../admin/images/edit.gif);"--%>
                               <%--href="userManager.jsp?dbName=<%=dbName%>"><fmt:message--%>
                                    <%--key="admin.console.manage.database"/></a>--%>
                            <%--<a class="icon-link"--%>
                               <%--style="background-image:url(../admin/images/delete.gif);"--%>
                               <%--onclick="deleteQuery(document.getElementById('<%//=tenantDomain%>').value);"--%>
                               <%--href="databases.jsp#"><fmt:message--%>
                                    <%--key="admin.console.delete.database"/></a>--%>
                        <%--</td>--%>
                    <%--</tr>--%>


                    <tr>
                        <td class="buttonRow" colspan="2">
                            <input class="button" type="submit"
                                   value="<fmt:message key="admin.console.add"/>"
                                   onclick="document.dataForm.action = 'manageUserProcessor.jsp'"/>

                            <input class="button" type="button"
                                   value="<fmt:message key="admin.console.cancel"/>"
                                   onclick="document.location.href = 'userManager.jsp?dbName=<%=dbName%>'"/>

                        </td>
                    </tr>
  