<%@ page import="org.apache.axis2.context.ConfigurationContext" %>
<%@ page import="org.wso2.carbon.CarbonConstants" %>
<%@ page import="org.wso2.carbon.adminconsole.ui.AdminConsoleClient" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIUtil" %>
<%@ page import="org.wso2.carbon.utils.ServerConstants" %>
<%@ page import="org.wso2.carbon.adminconsole.ui.beans.DatabaseInstanceInfo" %>
<!--
~ Copyright (c) 2005-2010, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
~
~ WSO2 Inc. licenses this file to you under the Apache License,
~ Version 2.0 (the "License"); you may not use this file except
~ in compliance with the License.
~ You may obtain a copy of the License at
~
~ http://www.apache.org/licenses/LICENSE-2.0
~
~ Unless required by applicable law or agreed to in writing,
~ software distributed under the License is distributed on an
~ "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
~ KIND, either express or implied. See the License for the
~ specific language governing permissions and limitations
~ under the License.
-->
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib uri="http://wso2.org/projects/carbon/taglibs/carbontags.jar" prefix="carbon" %>

<script type=text/javascript src="js/uiValidator.js"></script>

<fmt:bundle basename="org.wso2.carbon.adminconsole.ui.i18n.Resources">
    <link rel="stylesheet" type="text/css" href="../resources/css/registry.css"/>

    <carbon:breadcrumb
            label="Edit Database Instance"
            resourceBundle="org.wso2.carbon.adminconsole.ui.i18n.Resources"
            topPage="false"
            request="<%=request%>"/>

    <%!
        private String getJdbcDriver (String instanceUrl) {
            String prefix = instanceUrl.split(":")[1];
            if ("mysql".equals(prefix)) {
                return "com.mysql.jdbc.Driver";
            } else if ("oracle".equals(prefix)) {
                return "oracle.jdbc.driver.OracleDriver";
            } else if ("sqlserver".equals(prefix)) {
                return "";
            }
            return "";
        }

        private String getDatabasePrefix (String instanceUrl) {
            if(instanceUrl != null && !"".equals(instanceUrl)) {
                return instanceUrl.split(":")[1];
            }
            return "";
        }
    %>

    <%
        String instanceName = request.getParameter("instanceName");
        String instanceUrl = request.getParameter("instanceUrl");
        String masterUsername = request.getParameter("masterUsername");
        String flag = request.getParameter("flag");
        String instanceType = request.getParameter("instanceType");

        instanceName = (instanceName == null) ? "" : instanceName;
        instanceUrl = (instanceUrl == null) ? "" : instanceUrl;
        masterUsername = (masterUsername == null) ? "" : masterUsername;
        flag = (flag == null) ? "edit" : flag;
        instanceType = (instanceType == null) ? "generic" : instanceType;

        String backendServerUrl = CarbonUIUtil.getServerURL(
            getServletConfig().getServletContext(),session);
        ConfigurationContext configContext = (ConfigurationContext) config.
            getServletContext().getAttribute(CarbonConstants.CONFIGURATION_CONTEXT);
        String cookie = (String) session.getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);
        AdminConsoleClient client = new AdminConsoleClient(cookie,backendServerUrl,configContext);

        DatabaseInstanceInfo instanceInfo = client.getDatabaseInstanceInfo(instanceName);

        if (instanceInfo != null) {
    %>

    <div id="middle">
        <h2><fmt:message key="admin.console.edit.instance.info"/></h2>

        <div id="workArea">

            <form method="post" action="instanceProcessor.jsp?flag=edit" name="addInstanceForm"
                  id="addInstanceForm" onsubmit="return validateInstanceProperties()">
                <table class="styledLeft">
                    <tr>
                        <td>
                            <table class="normal">
                                <tr>
                                    <td class="leftCol-med"><fmt:message
                                            key="admin.console.instance.name"/><font
                                            color='red'>*</font></td>
                                    <td><input value="<%=instanceName%>" id="instanceName"
                                               name="instanceName"
                                               size="30" type="text" readonly="readonly"></td>
                                </tr>
                                <tr>
                                    <td class="leftCol-med"><fmt:message
                                            key="admin.console.instance.type"/>
                                        <font color="red">*</font>
                                    </td>
                                    <td><label>
                                        <select name="databaseEngine" id="databaseEngine"
                                                onchange="setJDBCValues(this,document)">
                                            <%
                                                instanceType = this.getDatabasePrefix(instanceInfo.getInstanceUrl());
                                                if ("".equals(instanceType)) { %>
                                            <option value="#" selected="selected">--SELECT--</option>
                                            <% } else { %>
                                            <option value="">--SELECT--</option>
                                            <% }
                                                if ("mysql".equals(instanceType)) { %>
                                            <option id="mysql" selected="selected"
                                                    value="jdbc:mysql://[machine-name/ip]:[port]#com.mysql.jdbc.Driver">
                                                MySQL
                                            </option>
                                            <% } else { %>
                                            <option id="mysql"
                                                    value="jdbc:mysql://[machine-name/ip]:[port]#com.mysql.jdbc.Driver">
                                                MySQL
                                            </option>
                                            <% } if ("sqlserver".equals(instanceType)) { %>
                                            <option id="sqlserver" selected="selected"
                                                    value="jdbc:sqlserver://[HOST]:[PORT1433]#com.microsoft.sqlserver.jdbc.SQLServerDriver">
                                                Microsoft SQL Server
                                            </option>
                                            <% } else { %>
                                            <option id="sqlserver"
                                                    value="jdbc:sqlserver://[HOST]:[PORT1433]#com.microsoft.sqlserver.jdbc.SQLServerDriver">
                                                Microsoft SQL Server
                                            </option>
                                            <% } if ("oracle".equals(instanceType)) { %>
                                            <option id="oracle" selected="selected"
                                                    value="jdbc:oracle:[drivertype]:[username/password]@[host]:[port]#oracle.jdbc.driver.OracleDriver">
                                                Oracle
                                            </option>
                                            <% } else { %>
                                            <option id="oracle"
                                                    value="jdbc:oracle:[drivertype]:[username/password]@[host]:[port]#oracle.jdbc.driver.OracleDriver">
                                                Oracle
                                            </option>
                                            <% } %>
                                            <option id="generic" selected="selected" value="Generic#Generic">Generic
                                            </option>
                                        </select>
                                    </label>
                                    </td>
                                </tr>
                                <tr>
                                    <td align="left"><fmt:message key="admin.console.driver.class"/><font
                                            color="red">*</font></td>
                                    <td>
                                        <input id="driverClass" name="driverClass" size="30"
                                               type="text" value="<%=this.getJdbcDriver(instanceInfo.getInstanceUrl())%>"/>
                                    </td>
                                </tr>
                                <tr>
                                    <td align="left"><fmt:message
                                            key="admin.console.instance.url"/><font
                                            color='red'>*</font></td>
                                    <td><input value="<%=instanceInfo.getInstanceUrl()%>" id="instanceUrl"
                                               name="instanceUrl"
                                               size="60" type="text"></td>
                                </tr>
                                <tr>
                                    <td class="leftCol-med"><fmt:message
                                            key="admin.console.instance.username"/><font
                                            color='red'>*</font></td>
                                    <td><input value="<%=instanceInfo.getUsername()%>" id="username"
                                               name="username"
                                               size="30" type="text"></td>
                                </tr>
                                <tr>
                                    <td align="left"><fmt:message
                                            key="admin.console.instance.password"/><font
                                            color='red'>*</font></td>
                                    <td><input value="" id="password"
                                               name="password"
                                               size="30" type="password"></td>
                                </tr>
                            </table>
                        </td>
                    </tr>
                    <tr>

                        <td class="buttonRow" colspan="3">
                            <div id="connectionTestMsgDiv" style="display: none;"></div>
                            <input class="button" type="button"
                                   value="<fmt:message key="admin.console.test.connection"/>"
                                   onclick="validateInstanceProperties();testConnection();"/>

                            <input class="button" type="submit"
                                   value="<fmt:message key="admin.console.save"/>"/>

                            <input class="button" type="button"
                                   value="<fmt:message key="admin.console.cancel"/>"
                                   onclick="document.location.href = 'instances.jsp'"/>
                        </td>

                    </tr>
                </table>
            </form>
        </div>
    </div>

    <%
        } else {

    %>
    <script type="text/javascript">
        document.location.href = "instances.jsp";
    </script>
    <%
        }
    %>
</fmt:bundle>