<!--
~ Copyright (c) 2005-2010, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
~
~ WSO2 Inc. licenses this file to you under the Apache License,
~ Version 2.0 (the "License"); you may not use this file except
~ in compliance with the License.
~ You may obtain a copy of the License at
~
~ http://www.apache.org/licenses/LICENSE-2.0
~
~ Unless required by applicable law or agreed to in writing,
~ software distributed under the License is distributed on an
~ "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
~ KIND, either express or implied. See the License for the
~ specific language governing permissions and limitations
~ under the License.
-->
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib uri="http://wso2.org/projects/carbon/taglibs/carbontags.jar" prefix="carbon" %>
<%@ page import="org.apache.axis2.context.ConfigurationContext" %>
<%@ page import="org.apache.commons.logging.Log" %>
<%@ page import="org.apache.commons.logging.LogFactory" %>
<%@ page import="org.wso2.carbon.CarbonConstants" %>
<%@ page import="org.wso2.carbon.adminconsole.ui.AdminConsoleClient" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIUtil" %>
<%@ page import="org.wso2.carbon.utils.ServerConstants" %>
<%@ page import="java.util.ArrayList" %>
<%@ page import="java.util.Iterator" %>
<%@ page import="org.wso2.carbon.adminconsole.ui.beans.DatabaseInstanceInfo" %>

<fmt:bundle basename="org.wso2.carbon.adminconsole.ui.i18n.Resources">
    <carbon:breadcrumb
            label="Database Instances"
            resourceBundle="org.wso2.carbon.adminconsole.ui.i18n.Resources"
            topPage="false"
            request="<%=request%>"/>
    <script type="text/javascript" src="js/uiValidator.js"></script>
    <%
        Log log = LogFactory.getLog(this.getClass());
        AdminConsoleClient client = null;
        String instanceName;
        String instanceUrl;

        try {
            String backendServerUrl = CarbonUIUtil.getServerURL(config.getServletContext(), session);
            ConfigurationContext configContext =
                    (ConfigurationContext) config.getServletContext().getAttribute(CarbonConstants.CONFIGURATION_CONTEXT);
            String cookie = (String) session.getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);
            client = new AdminConsoleClient(cookie, backendServerUrl, configContext);
        } catch (Exception e) {
            String errorMsg = e.getLocalizedMessage();
            log.error(errorMsg);
        }
    %>

    <%
        ArrayList<DatabaseInstanceInfo> instances = null;
        if (client != null) {
            instances = (ArrayList<DatabaseInstanceInfo>) client.getInstanceList();
        }
        boolean hasRecords = false;
        Iterator iterator = null;
        if (instances != null && instances.size() > 0) {
            hasRecords = true;
            iterator = instances.iterator();
        }
    %>
    <div id="middle">
        <h2><fmt:message key="admin.console.instances"/></h2>

        <div id="workArea">
            <form method="post" action="instances.jsp" name="instanceDataForm"
                  onsubmit="return validateInstanceDataForm();">
                <table class="styledLeft" id="instanceTable">
                    <% if (hasRecords) {%>
                    <thead>
                    <tr>
                        <th width="20%"><fmt:message key="admin.console.instance.name"/></th>
                        <th width="20%"><fmt:message key="admin.console.instance.url"/></th>
                        <th width="60%"><fmt:message key="admin.console.actions"/></th>
                    </tr>
                    </thead>
                    <tbody>
                    <%
                        while (iterator.hasNext()) {
                            DatabaseInstanceInfo instance = (DatabaseInstanceInfo) iterator.next();
                            if (instance != null) {
                                instanceName = instance.getInstanceName();
                                instanceUrl = instance.getInstanceUrl();
                    %>
                    <tr id="tr_<%=instanceName%>">
                        <td id="td_<%=instanceName%>"><%=instanceName%></td>
                        <td id="td_<%=instanceUrl%>"><%=instanceUrl%></td>
                        <td>
                            <a class="icon-link"
                               style="background-image:url(../admin/images/edit.gif);"
                               onclick="redirectToEditPage(this)"><fmt:message
                                    key="admin.console.edit.instance"/></a>
                            <%--<a class="icon-link"--%>
                               <%--style="background-image:url(../admin/images/delete.gif);"--%>
                               <%--onclick="deleteInstance(document.getElementById('<%=instanceName%>').value);"--%>
                               <%--href="#"><fmt:message key="admin.console.drop.instance"/></a>--%>
                            <a class="icon-link"
                               style="background-image:url(../admin/images/delete.gif);"
                               onclick="removeInstance(this);"
                               href="#"><fmt:message key="admin.console.drop.instance"/></a>
                        </td>
                    </tr>
                    <%
                                }
                            }
                        }
                    %>
                    <tr>
                        <td colspan="3">
                            <a class="icon-link"
                               style="background-image:url(../admin/images/add.gif);"
                               href="addInstance.jsp"><fmt:message
                                    key="admin.console.add.new.instance"/></a>
                        </td>
                    </tr>

                    </tbody>
                </table>
            </form>
        </div>
    </div>
</fmt:bundle>
