function validateInstanceProperties() {
    var instanceName = document.getElementById("instanceName").value.trim();
    var instanceUrl = document.getElementById("instanceUrl").value.trim();
    var username = document.getElementById("username").value.trim();
    var password = document.getElementById("password").value.trim();
    var driverClass = document.getElementById("driverClass").value.trim();
    var databaseEngine = document.getElementById("databaseEngine");
    var instanceType = databaseEngine[databaseEngine.selectedIndex].value.trim();

    if (instanceName == '' || instanceName == null) {
        CARBON.showWarningDialog("Instance Name Cannot Be Left Blank");
        return false;
    }
    if (instanceType == '' || instanceType == null) {
        CARBON.showWarningDialog("Select A Valid Instance Type");
        return false;
    }
    if (driverClass == '' || driverClass == null) {
        CARBON.showWarningDialog("Driver Class Cannot Be Left Blank");
        return false;
    }
    if (instanceUrl == '' || instanceUrl == null) {
        CARBON.showWarningDialog("Instance Url Field Cannot Be Left Blank");
        return false;
    }
    if (username == '' || username == null) {
        CARBON.showWarningDialog("Master Username Field Cannot Be Left Blank");
        return false;
    }
    if (password == '' || password == null) {
        CARBON.showWarningDialog("Master Password Field Cannot Be Left Blank");
        return false;
    }
    return true;
}

function validateDatabaseProperties() {
    var instanceNameBox = document.getElementById("instanceName");
    var instanceName = instanceNameBox[instanceNameBox.selectedIndex].value.trim();
    var dbName = document.getElementById("dbName").value.trim();
    var defaultUsername = document.getElementById("defaultUsername").value.trim();
    var defaultUserPassword = document.getElementById("defaultUserPassword").value.trim();
    var defaultUserRepeatPassword = document.getElementById("defaultUserRepeatPassword").value.trim();
    if (instanceName == '' || instanceName == null) {
        CARBON.showWarningDialog("Select A Valid Instance Name");
        return false;
    }
    if (dbName == '' || dbName == null) {
        CARBON.showWarningDialog("Database Name Cannot Be Left Blank");
        return false;
    }
    if (defaultUsername == '' || defaultUsername == null) {
        CARBON.showWarningDialog("Default Username Cannot Be Left Blank");
        return false;
    }
    if (defaultUserPassword == '' || defaultUserPassword == null) {
        CARBON.showWarningDialog("Default Password Cannot Be Left Blank");
        return false;
    }
    if (defaultUserRepeatPassword == '' || defaultUserRepeatPassword == null) {
        CARBON.showWarningDialog("Repeat Password Cannot Be Left Blank");
        return false;
    }
    if (defaultUserPassword != defaultUserRepeatPassword) {
        CARBON.showErrorDialog("Password And Repeat Password Values Do Not Match");
        return false;
    }
    return true;
}

function deleteInstance(obj) {
    function forwardToDel() {
        var delElement = document.getElementById(obj);
        var instanceTable = document.getElementById("instanceTable");
        instanceTable.removeChild(delElement);
        document.location.href = "instances.jsp";
    }

    CARBON.showConfirmationDialog("Do you want to drop instance " + obj + "?", forwardToDel());
}

function validateInstanceData() {
    var instanceName = document.getElementById("instanceName").value;
    var instanceUrl = document.getElementById("instanceUrl").value;
    var username = document.getElementById("username").value;
    var password = document.getElementById("password").value;

    if (instanceName == "") {
        CARBON.showWarningDialog("Instance Name Field Cannot Be Left Blank");
        return;
    }
    if (instanceUrl == "") {
        CARBON.showWarningDialog("Instance Url Field Cannot Be Left Blank");
        return;
    }
    if (username == "") {
        CARBON.showWarningDialog("Username Field Cannot Be Left Blank");
        return;
    }
    if (password == "") {
        CARBON.showWarningDialog("Password Field Cannot Be Left Blank");
        return;
    }
    document.dataForm.action = 'instanceProcessor.jsp';
}

function setJDBCValues(obj, document) {
    var selectedValue = obj[obj.selectedIndex].value;
    var jdbcUrl = selectedValue.substring(0, selectedValue.indexOf("#"));
    document.getElementById("driverClass").value = selectedValue.substring(selectedValue.indexOf("#") + 1, selectedValue.length);
    document.getElementById("instanceUrl").value = jdbcUrl;
}

function displayMsg(msg) {
    var successMsg = new RegExp("^Database connection is successful with driver class");
    if (msg.search(successMsg) == -1) //if match failed
    {
        CARBON.showErrorDialog(msg);
    } else {
        CARBON.showInfoDialog(msg);
    }

}

function testConnection() {
    var driverClass = document.getElementById('driverClass').value.trim();
    var jdbcUrl = document.getElementById('instanceUrl').value.trim();
    var username = document.getElementById('username').value.trim();
    var password = document.getElementById('password').value.trim();
    var url = 'connection_test_ajaxprocessor.jsp?driverClass=' + driverClass + '&jdbcUrl=' +
            jdbcUrl + '&username=' + username + '&password=' + password;
    jQuery('#connectionTestMsgDiv').load(url, displayMsg);
    return false;
}

function dropDatabase(obj) {
    var rowId = $(obj).parents('tr:eq(0)').attr('id');
    var temp = rowId.split('_');
    var instanceName = temp[1].trim();
    var dbName = temp[2].trim();
    document.location.href = "databaseProcessor.jsp?instanceName=" +
            instanceName + "&dbName=" + dbName + "&flag=drop";
}

function removeInstance(obj) {
    var rowId = $(obj).parents('tr:eq(0)').attr('id');
    var instanceName = rowId.substring("tr_".length, rowId.length);
    document.location.href = "instanceProcessor.jsp?instanceName=" + instanceName + "&flag=remove";
}

function redirectToEditPage(obj) {
    var rowId = $(obj).parents('tr:eq(0)').attr('id');
    var instanceName = rowId.substring("tr_".length, rowId.length);
    document.location.href = "editInstance.jsp?instanceName=" + instanceName + "&flag=edit";
}

